/*
 * List
 *
 * Author:   (, 3, ..:80527)
 *
 *  ( 11)
 *  1 ( )
 */
#include <iostream>

using namespace std;

struct list {
	int data;
	list *next;
};

//  List
class List {

public:
	List();
	void insertFront(int);
	void insertAt(int, int);
	void deleteAt(int);
	int getAt(int);
	void setAt(int, int);
	int getSize();
	void print(FILE*);
private:
	void goTo(int);
	list *first;
	list *ptr;
};

// Constructor
List::List() {
	ptr = NULL;
	first = NULL;
}

//   x     
void List::insertFront(int x) {
	list *new_element;
	new_element = (list*)malloc(sizeof(*new_element));
	if(new_element == NULL) {
		cout<<"Error: no enough memory!"<<endl;
		return ;
	}

	new_element->next = first;
	first = new_element;
	new_element->data = x;
	ptr = first;
}

//   x   pos
void List::insertAt(int pos, int x) {
	if(ptr == NULL || pos == 0) { //    
		insertFront(x);
		return ;
	}

	list *new_element;
	new_element = (list*)malloc(sizeof(*new_element));
	if(new_element == NULL) {
		cout<<"Error: no enough memory!"<<endl;
		return ;
	}

	goTo(pos);
	new_element->next = ptr->next;
	ptr->next = new_element;
	new_element->data = x;
}

//     pos
void List::deleteAt(int pos) {
	/*if(ptr == NULL) { //    
		cout<<"Error: no elements"<<endl;
		return ;
	}*/
	
	list *to_delete;
	if(pos == 0) { //       
		to_delete = first;
		first = first->next;
		free(to_delete);
		ptr = first;
		return ;
	}

	goTo(pos);
	if(ptr->next == NULL) { //  ,    	
		cout<<"Error: no element"<<endl;
		return ;
	}
	to_delete = ptr->next;
	ptr->next = to_delete->next;
	free(to_delete);
	ptr = first;
}

//     pos
int List::getAt(int pos) {
	goTo(pos+1);
	return ptr->data;
}

//   x     pos
void List::setAt(int pos, int x) {
	ptr = first;
	goTo(pos+1);
	ptr->data = x;
}

//    
int List::getSize() {
	int length = 0;
	ptr = first;
	while(ptr != NULL) {
		length++;
		ptr = ptr->next;
	}
	return length;
}

//       fout
void List::print(FILE *fout) {
	if(fout == NULL) {
		cout<<"Cannot open file!"<<endl;
		return ;
	}
	ptr = first;
	while(ptr != NULL) {
		cout<<ptr->data<<" ";
		fprintf(fout, "%d ", ptr->data);
		ptr = ptr->next;
	}
	cout<<endl;
	fprintf(fout, "\n");
}

//      pos
void List::goTo(int pos) {
	ptr = first;
	for(int i = 1; i < pos; i++) {
		ptr = ptr->next;
		if(ptr == NULL) { //  ,    	
			cout<<"Error: no element"<<endl;
			return ;
		}
	}
}